/*
	STRUKTUR.H

	Module zum C-Kurs, Teil 15
	http://members.aol.com/pcdbascht/ckmain.htm

  	(c) 1998, 1999 Sebastian Cyris
*/

#ifndef _struktur_h
#define _struktur_h

/*	Struktur einer einfachverketteten Liste */

struct evListe 
{ 
	double Element; 
	
	struct evListe *next;
};

typedef struct evListe EVL;

/*	Struktur einer einfachverketteten Char Liste */

struct CharEvListe 
{ 
	char Element; 
	
	struct CharEvListe *next;
};

typedef struct CharEvListe CharEVL;

/*	Struktur einer mehrfachverketteten Liste */

struct mvListe 
{ 
	double Element; 
	
	struct mvListe *previous; 
	struct mvListe *next;
};

typedef struct mvListe MVL;

/* Struktur eines Baumes */

struct BKnoten 
{ 
	char key; 

	struct BKnoten *l; 
	struct BKnoten *r;
	struct BKnoten *p;
};

typedef struct BKnoten Knoten;

/*	Modulspezifikationen zu den einfachverketteten Listen */

EVL		*EvlEinsetzen	(EVL *Start, double Wert);
EVL		*EvlLoeschen	(EVL *Start, int Index);
void	evlZeigen		(EVL *Start);

/* Modulspezifikation zu Stacks, realisiert ber einfachverkettete Listen */

EVL *Push	(EVL *Stack, double Wert);
EVL *Pop	(EVL *Stack);

/* Modulspezifikation zu Queues, realisiert ber einfachverkettete Listen */

EVL *Put	(EVL *Queue, double Wert);
EVL *Get	(EVL *Queue);

/* Modulspezifikation zu Bumen */

void	besuchen		(Knoten *Baum);
void	besuchenL		(EVL *Baum);

#endif